

#include "stdafx.h"
#include "MenuExample.h"
#include "MenuExampleDlg.h"
#include "MenuItem.h"
#include "ProIniFile.h"
#include "ProIniSection.h"



/////////////////////////////////////////////////////////////////////////////
// CMenuExampleDlg Dialogfeld

CMenuExampleDlg::CMenuExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMenuExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMenuExampleDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_iY=0;
	m_pBitmap=NULL;
	m_pItemHigh=NULL;
	m_pItemRoot=NULL;
	m_strFirma="";
}

CMenuExampleDlg::~CMenuExampleDlg()
{
	if(m_pBitmap!=NULL) {
		delete m_pBitmap;
	}
}


void CMenuExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMenuExampleDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMenuExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CMenuExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMenuExampleDlg Nachrichten-Handler

BOOL CMenuExampleDlg::OnInitDialog()
{
	HRSRC hResource;
	HGLOBAL hGlobal;
	LPVOID pvResource;
	CString strRes;

	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	m_pBitmap=new CBitmap;
	m_pBitmap->LoadBitmap(IDB_BITMAP1);
	m_fontNormal.CreatePointFont(100,"Arial",NULL);
	m_strFirma="Beispiel GmbH";


	strRes.Format("#%ld",IDR_MYTEXT1);
	hResource=FindResource(
		AfxGetResourceHandle(),
		strRes,
		"MYTEXT"
		);
	hGlobal=LoadResource(
		NULL,
		hResource
		);
	pvResource=LockResource(hGlobal);
	LoadMenuFromFile((LPCTSTR)pvResource);

	
	
	return TRUE;
}


void CMenuExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);


		CPaintDC* pdc=&dc;
		CRect rcBounds;
		GetWindowRect(&rcBounds);
		// die Skalierung fr diesen CDC festlegen
		// MM_TEXT=Pixel
		pdc->SetMapMode(MM_TEXT);
		CFont* pfontOld=(CFont *)pdc->SelectObject(&m_fontNormal);

		// Rnder auerhalb des defnierten Bereiches wei frben
		CRect rectFill;
		rectFill.top=0;
		rectFill.bottom=rcBounds.bottom;
		rectFill.left=174;
		rectFill.right=rcBounds.right;
		pdc->FillRect(rectFill, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));

		rectFill.top=480;
		rectFill.left=0;
		pdc->FillRect(rectFill, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	
		// blaues Rechteck (0,0,174,23)
		CBrush brushBlue;
		brushBlue.CreateSolidBrush(RGB(8,82,140));
		CRect rectBlue(0,0,174,23);
		pdc->FillRect(&rectBlue,&brushBlue);
		// schwarze Linien auf diesem!
		CBrush brushBlack;
		brushBlack.CreateSolidBrush(RGB(0,0,0));
		CBrush* pbrushOld=pdc->SelectObject(&brushBlack);
		pdc->MoveTo(0,0);
		pdc->LineTo(173,0);
		pdc->LineTo(173,22);
		pdc->LineTo(0,22);
		pdc->LineTo(0,0);
		// Hintergrungfarbe
		pdc->SetBkColor(RGB(8,82,140));
		// TextFarbe setzen
		pdc->SetTextColor(RGB(255,255,255));
		pdc->TextOut(5,4,"Beispielfirma");

		// mit Bitmap
		CDC dcImage;
		if (!dcImage.CreateCompatibleDC(pdc)) {
			Beep(440,125);
			return;
		}
		BITMAP bm;
		m_pBitmap->GetBitmap(&bm);
		// Bild zeichnen
		CBitmap* pOldBitmap = dcImage.SelectObject(m_pBitmap);
		pdc->BitBlt(0, 23, bm.bmWidth, bm.bmHeight, &dcImage, 0, 0, SRCCOPY);
		dcImage.SelectObject(pOldBitmap);

		// das Men zeichnen
		DrawMenu(pdc);

		pdc->SelectObject(pbrushOld);
		pdc->SelectObject(pfontOld);


	}
}

HCURSOR CMenuExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



// Das Hauptmen zeichnen
void CMenuExampleDlg::DrawMenu(CDC* pdc)
{
	// Hintergrungfarbe
	pdc->SetBkColor(RGB(190,190,190));
	CMenuItem* pItem=m_pItemRoot;
	CString strName;

	m_iY=STARTY;
	while(pItem!=NULL) {
		// wenn das Item markiert ist, wird es mit grauem Rand dargestellt,
		// sonst mit dem normalen Hintergrund
		if(pItem->m_bHigh) {
			pdc->SetBkMode(OPAQUE);
		}
		else {
			pdc->SetBkMode(TRANSPARENT);
		}
		strName=pItem->m_strName;
		if(strName.GetLength()>0) {
			// keine leren Item darstellen!
			if(pItem->m_iID!=99) {
				if(pItem->m_bExpanded) {
					strName="- "+strName;
				}
				else {
					strName="+ "+strName;
				}	
			}
			else {
				// das Item 99 (Programm beenden) eine Zeile tiefer darstellen
//				if(m_iY<480-DELTAY) m_iY+=DELTAY;
			}
			if(pItem->m_bEnabled) {
				pdc->SetTextColor(RGB(8,82,140));
			}
			else {
				pdc->SetTextColor(RGB(128,128,128));
			}
			pdc->TextOut(STARTX,m_iY,strName);
			pItem->m_iTop=m_iY;
			pItem->m_bTopLevel=TRUE;
			m_iY+=DELTAY;
			if(pItem->m_bExpanded) {
				// bei Expandet Top Level Items, das Untermenu mit anzeigen,
				// sonst net
				if(pItem->m_pSubItem!=NULL) DrawSubMenu(pdc,pItem,1);
			}
		}
		m_iY+=DELTAY;
		pItem=pItem->m_pNextItem;
		if(m_iY>=480-DELTAY) break;
	}
}

// ein Untermen zeichnen
void CMenuExampleDlg::DrawSubMenu(CDC *pdc, CMenuItem* pItemRoot, int iLevel)
{
	CMenuItem* pItem=pItemRoot->m_pSubItem;
	CString strName;

	int iY=STARTY;
	while(pItem!=NULL) {
		// wenn das Item markiert ist, wird es mit grauem Rand dargestellt,
		// sonst mit dem normalen Hintergrund
		if(pItem->m_bHigh) {
			pdc->SetBkMode(OPAQUE);
		}
		else {
			pdc->SetBkMode(TRANSPARENT);
		}
		strName=pItem->m_strName;
		if(pItem->m_pSubItem!=NULL) {
			if(pItem->m_iID==28) {
				int u=0;
			}
			if(pItem->m_bEnabled) {
				pdc->SetTextColor(RGB(8,82,140));
			}
			else {
				pdc->SetTextColor(RGB(128,128,128));
			}
			if(pItem->m_bExpanded) {
				strName="- "+strName;
			}
			else {
				strName="+ "+strName;
			}	
		}
		else {
			if(pItem->m_bEnabled) {
				pdc->SetTextColor(pItem->m_colText);
			}
			else {
				pdc->SetTextColor(pItem->m_colGray);
			}
		}
		if(strName.GetLength()>0) {
			// keine leren Item darstellen!
			pdc->TextOut(STARTX+iLevel*DELTAX,m_iY,strName);
			pItem->m_iTop=m_iY;
		}
		m_iY+=DELTAY;
		if(pItem->m_pSubItem!=NULL && pItem->m_bExpanded) {
			DrawSubMenu(pdc,pItem,iLevel+1);
		}
		pItem=pItem->m_pNextItem;
		if(m_iY>=480-DELTAY) break;
	}
}


// ein Item neu zeichnen
void CMenuExampleDlg::RedrawItem(CMenuItem *pItem)
{
	CRect rect;
	rect.left=0;
	rect.right=173;
	rect.top=pItem->m_iTop;
	rect.bottom=pItem->m_iTop+DELTAY+5;
	InvalidateRect(&rect,FALSE);
}

// ermittelt das letzte UnterItem des Vorgngers;
// diese Funktion wird aufgerufen, wenn mit den Cursortasten 
// der Fokus nach oben bewegt wird, um zu ermitteln,
// auf welches Element er gesetzt werden soll
CMenuItem* CMenuExampleDlg::GetLastSubOfPrecedor(CMenuItem *pItem)
{
	CMenuItem* pItemUp=pItem->m_pForeItem;
	if(pItemUp==NULL) return NULL;
	CMenuItem* pItemRet=pItemUp;
	while(pItemUp!=NULL) {
		pItemRet=pItemUp;
		if(pItemUp->m_pSubItem!=NULL && pItemUp->m_bExpanded) {
			pItemUp=pItemUp->m_pSubItem;
		}
		else if(pItemUp->m_pNextItem!=NULL) {
			pItemUp=pItemUp->m_pNextItem;
		}
		else {
			pItemUp=NULL;
		}
		if(pItemUp==pItem) {
			pItemRet=NULL;
			break;
		}
	}
	return pItemRet;
}

/*
// beim einfachen klick auf ein MenItem, das kein Untermen hat:
// einen Event rauswerfen
void CMenuExampleDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// das Item ermitteln, auf das geklickt wurde
	CMenuItem* pItem=GetItemByY(m_pItemRoot,point.y);
	if(pItem!=NULL) {
		if(pItem->m_bEnabled) {
			if(m_pItemHigh!=NULL) m_pItemHigh->m_bHigh=FALSE;
			pItem->m_bHigh=TRUE;
			RedrawItem(pItem);
			if(m_pItemHigh!=NULL) RedrawItem(m_pItemHigh);
			m_pItemHigh=pItem;
			if(pItem->m_pSubItem==NULL) FireActivateItem(pItem->m_iID);
		}
	}

	COleControl::OnLButtonDown(nFlags, point);
}
*/

// anhand der Y koordinate (des Punktes, auf den geklickt wurde),
// das an der Stelle befindliche Item ermitteln
CMenuItem* CMenuExampleDlg::GetItemByY(CMenuItem* pItem, int iY)
{
	CMenuItem* pItemFound=NULL;
	CMenuItem* pItemSub=NULL;
	while(pItem!=NULL) {
		if(iY>=pItem->m_iTop && iY<pItem->m_iTop+DELTAY) {
			pItemFound=pItem;
			break;
		}
		if(pItem->m_pSubItem!=NULL && pItem->m_bExpanded==TRUE) {
			pItemSub=GetItemByY(pItem->m_pSubItem,iY);
			if(pItemSub!=NULL) {
				pItemFound=pItemSub;
				break;
			}
		}
		pItem=pItem->m_pNextItem;
	}
	return pItemFound;
}

// ein Item anhand seiner ID ermitteln
CMenuItem* CMenuExampleDlg::GetItemByID(CMenuItem* pItem, int iID)
{
	CMenuItem* pItemFound=NULL;
	CMenuItem* pItemSub=NULL;
	while(pItem!=NULL) {
		if(pItem->m_iID==iID) {
			pItemFound=pItem;
			break;
		}
		if(pItem->m_pSubItem!=NULL) {
			pItemSub=GetItemByID(pItem->m_pSubItem,iID);
			if(pItemSub!=NULL) {
				pItemFound=pItemSub;
				break;
			}
		}
		pItem=pItem->m_pNextItem;
	}
	return pItemFound;
}


// eine Menu.ini laden
long CMenuExampleDlg::LoadMenuFromFile(LPCTSTR lpszMenu) 
{
	CProIniFile file;
	CProIniSection* pSec;
	CMenuItem* pItem;
	CMenuItem* pItemParent=NULL;
	CMenuItem* pItemOld=NULL;
	CString strTyp;
	CString strName;

	file.FromString(lpszMenu);
	
	int iID;
	int i=0;
	file.SetSectionPos(0);
	while((pSec=file.GetNextSectionRaw())!=NULL) {
		pItem=new CMenuItem;
		if(i==0) {
			m_pItemRoot=pItem;
		}
		strTyp=pSec->GetString("Typ");
		strTyp.MakeLower();
		strName=pSec->GetListEntry(pSec->GetString("Name"),0,',');
		if(strTyp=="menu") {
			// Eintrag in oberster Ebene!
			if(pItemParent!=NULL) pItemOld=pItemParent;
			pItemParent=NULL;
			pItem->m_bTopLevel=TRUE;
			pItem->m_strName=strName;
			iID=atoi(pSec->GetTitle());
#ifdef _DEBUG
			// Sicherstellen, da diese ID eindeutig ist
			ASSERT(GetItemByID(m_pItemRoot,iID)==NULL);
#endif
			pItem->m_iID=iID;
			if(i!=0) {
				pItemOld->m_pNextItem=pItem;
				pItem->m_pForeItem=pItemOld;
				pItemOld=pItem;
			}
			else {
				pItemOld=pItem;
				m_pItemRoot=pItem;
			}
			AddSubMenu(pItem,&file);
		}
		i++;
	}
	return 0;
}


// den Nachfolger des Parents einer Subliste ermitteln
CMenuItem* CMenuExampleDlg::GetParentOfSubList(CMenuItem *pItem)
{
	while((pItem->m_pForeItem!=NULL)) {
		pItem=pItem->m_pForeItem;
	}
	return pItem->m_pParent;
}




// ein MenItem enablen/disablen
long CMenuExampleDlg::EnableItem(long lID, long lEnable) 
{
	CMenuItem* pItem;
	pItem=GetItemByID(m_pItemRoot,lID);
	// falsche ID; es gibt kein Item zu dieser ID
	if(pItem==NULL) return -1;
	// ist es ein TopLevelItem ?
	if(pItem->m_bTopLevel) {
		if(lEnable==0) {
			// soll disabled werden
			// dann das Item kollabieren
			pItem->m_bExpanded=FALSE;
			pItem->m_bEnabled=FALSE;
			Invalidate(FALSE);
		}
		else {
			pItem->m_bEnabled=TRUE;
			// Statur enabled/disabled bleibt in diesem Fall gleich
			RedrawItem(pItem);
		}
	}
	else {
		pItem->m_bEnabled=(lEnable!=0);
		RedrawItem(pItem);
	}

	return 0;
}

long CMenuExampleDlg::SetItemColor(long lID, long lColor) 
{
	CMenuItem* pItem;
	pItem=GetItemByID(m_pItemRoot,lID);
	// falsche ID; es gibt kein Item zu dieser ID
	if(pItem==NULL) return -1;
	pItem->m_colText=(ULONG)lColor;
	RedrawItem(pItem);

	return 0;
}

// Beim Laden des Mnes ein Untermenu hinzufgen;
// bergeben wird ein Zeiger auf den Parent des Untermens, 
// sowie ein Zeiger auf die IniFile.
long CMenuExampleDlg::AddSubMenu(CMenuItem *pItemParent, CProIniFile *pFile)
{
	CProIniSection* pSec;
	CMenuItem* pItem=NULL;
	CMenuItem* pItemOld=NULL;
	CString strTyp;
	CString strName;
	int iID;

	while((pSec=pFile->GetNextSectionRaw())) {
		strTyp=pSec->GetString("Typ");
		strTyp.MakeLower();
		strName=pSec->GetListEntry(pSec->GetString("Name"),0,',');
		if(strTyp=="menu") 
		{
			pFile->GoBack();
			break;
		}
		else if(strTyp=="submenu") {
			if(pItemParent->m_bTopLevel) {
				// wenn in 1. Unterbene, dann hier in die 2. heruntergehen
				strName=pSec->GetListEntry(pSec->GetString("Name"),0,',');
				iID=atoi(pSec->GetTitle());
#ifdef _DEBUG
				// Sicherstellen, da diese ID eindeutig ist
				ASSERT(GetItemByID(m_pItemRoot,iID)==NULL);
#endif
				pItem=new CMenuItem;
				if(pItemOld==NULL) {
					// erstes Item in der Subkette
					pItemParent->m_pSubItem=pItem;
					pItem->m_pParent=pItemParent;
				}
				else {
					// weiteres Item in der Subkette
					pItemOld->m_pNextItem=pItem;
					pItem->m_pForeItem=pItemOld;
				}
				pItemOld=pItem;
				pItem->m_iID=iID;
				pItem->m_strName=strName;
				// jetzt das Untermen hinzufgen
				AddSubMenu(pItem,pFile);
			}
			else {
				// wenn in 2. Unterebene, dann nach diesem (weitere) Submenu
				// abbrechen
				pFile->GoBack();
				break;
			}
		}
		else if(strTyp=="dlg") {
			strName=pSec->GetListEntry(pSec->GetString("Name"),0,',');
			iID=atoi(pSec->GetTitle());
#ifdef _DEBUG
			// Sicherstellen, da diese ID eindeutig ist
			ASSERT(GetItemByID(m_pItemRoot,iID)==NULL);
#endif
			pItem=new CMenuItem;
			if(pItemOld==NULL) {
				// erstes Item in der Subkette
				pItemParent->m_pSubItem=pItem;
				pItem->m_pParent=pItemParent;
			}
			else {
				// weiteres Item in der Subkette
				pItemOld->m_pNextItem=pItem;
				pItem->m_pForeItem=pItemOld;
			}
			pItemOld=pItem;
			pItem->m_iID=iID;
			pItem->m_strName=strName;
		}
		else {
			// illegaler Typ! mu menu, submenu oder dlg sein!
			ASSERT(FALSE);
		}
	}
	return 0;

}

// setzt den Focus auf ein Item
void CMenuExampleDlg::SetItem(long lID) 
{
	CMenuItem* pItem=GetItemByID(m_pItemRoot,lID);
	if(pItem!=NULL) {
		if(m_pItemHigh!=NULL) {
			m_pItemHigh->m_bHigh=FALSE;
			RedrawItem(m_pItemHigh);
		}
		m_pItemHigh=pItem;
		m_pItemHigh->m_bHigh=TRUE;
		RedrawItem(pItem);
	}
	else {
		// es wurde kein gltiges Item angegeben;
		// dann den Focus lschen
		if(m_pItemHigh!=NULL) {
			m_pItemHigh->m_bHigh=FALSE;
			RedrawItem(m_pItemHigh);
			m_pItemHigh=NULL;
		}
	}
}

void CMenuExampleDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// das Item ermitteln, auf das geklickt wurde
	CMenuItem* pItem=GetItemByY(m_pItemRoot,point.y);
	if(pItem!=NULL) {
		if(pItem->m_bEnabled) {
			if(m_pItemHigh!=NULL) m_pItemHigh->m_bHigh=FALSE;
			pItem->m_bHigh=TRUE;
			RedrawItem(pItem);
			if(m_pItemHigh!=NULL) RedrawItem(m_pItemHigh);
			m_pItemHigh=pItem;
			pItem->m_bExpanded=!(pItem->m_bExpanded);
			Invalidate(FALSE);
		}
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}
