
#include "stdafx.h"
#include "ProIniSection.h"

CProIniSection::CProIniSection()
{
}

// ein String an eine Section anfgen
void CProIniSection::AddString(CString str)
{
	CString* pstr=new CString;
	*pstr=str;
	m_list.AddTail((CString *)pstr);
}

// den Inhalt der Section in einer Messageox anzeigen;
// dient zu Debug-Zwecken
void CProIniSection::Show() const
{
	CString strResult="";
	CString* pstr;
	int i,imax;
	imax=m_list.GetCount();
	for(i=0;i<imax;i++)
	{
		pstr=(CString *)m_list.GetAt(m_list.FindIndex(i));
		strResult=strResult+*pstr+"\15\12";
	}
	MessageBox(NULL,strResult,"CProIniSection::Show",MB_ICONINFORMATION|MB_OK);
}


CProIniSection::~CProIniSection()
{
	CString* pstr;
	while(!m_list.IsEmpty())
	{
		pstr=(CString *)m_list.GetTail();
		m_list.RemoveTail();
		delete pstr;
	}
}

// den Titel der Section ermitteln
// der Header (1. Zeile) sollte die Form haben:
// [Name] etc.
CString CProIniSection::GetTitle() const
{
	if(m_list.IsEmpty()) return "";
	CString str=*((CString *)m_list.GetHead());
	CString strReturn;
	char* pcBegin=(char *)(LPCSTR)str;
	char* pcEnd;
	char c;
	char cbuf[100];
	
	// der Header hat die Form
	// [ test ] etc.
	while((c=*pcBegin)=='[' || c==' ') pcBegin++;
	pcEnd=pcBegin;
	while((c=*pcEnd)!=']' && c!=0) pcEnd++;

	memset((void *)cbuf,0,100);
	strncpy(cbuf,pcBegin,(size_t)(pcEnd-pcBegin));

	strReturn=cbuf;
	return strReturn;
}

// den Titel einer Section setzen
void CProIniSection::SetTitle(CString strTitle)
{
	CString strTemp;
	strTemp.Format("[%s]",strTitle);
	if(GetCount()==0) {
		// Section bisher noch leer
		// jatzt also String anfgen
		AddString(strTemp);
	}
	else {
		SetString(0,strTemp);
	}
}


// einen String der Section ausgeben
CString CProIniSection::GetString(int inr) const
{
	CString *pstr;
	pstr=(CString *)m_list.GetAt(m_list.FindIndex(inr));
	if(pstr==NULL) return "";
	else return *pstr;
}

// einen String der Section ausgeben,
// anhand des Wertes, der vor dem '=' steht
CString CProIniSection::GetString(LPCTSTR lpszName) const
{
	POSITION pos;
	CString *pstr;
	CString strTemp;
	CString strReturn="";

	for( pos = m_list.GetHeadPosition(); pos != NULL; ){
		pstr=(CString *)m_list.GetNext( pos );
		strTemp=GetBeforeEqual(*pstr);
		// wenn ohne Bercksichtigung der Gro/kleinscheribung gleich...
		if(strTemp.CompareNoCase(lpszName)==0) {
			strReturn=GetAfterEqual(*pstr);
			break;
		}
	}
	return strReturn;
}

// die Anzahl an Strings ermitteln
int CProIniSection::GetCount() const
{
	return m_list.GetCount();
}


// aus einer Wortsequenz (getrennt durch Spaces oder Kommata) das Wort nr. iWord
// ermitteln
CString CProIniSection::GetWord(CString strArg, int iWord) const
{
	CString str;
	int i;
	char c;
	char cbuf[100];
	char* pc=(char *)(LPCSTR)strArg;
	char* pcEnd;

	// bis zum Wort nr. iWord vorgehen
	i=0;
	while((c=*pc++)!=0 && i<iWord)
	{
		if(c==' ' || c==',') i++;
	}
	// Stringende erreicht, bevor das gesuchte Wort gefunden wurde ?
	if(c==0) return "";
	memset((void *)cbuf,0,100);

	pc--;
	pcEnd=pc;
	while((c=*pcEnd)!=' ' && c!=',' && c!=0) pcEnd++;

	strncpy(cbuf,pc,(size_t)(pcEnd-pc));
	str=cbuf;
	return str;
}

// den Anteil eines Strings NACH einem '=' zurckgeben
CString CProIniSection::GetAfterEqual(CString strArg) const
{
	CString strReturn;
	char cbuf[100];
	char* pcEnd;
	char* pc;
	memset((void *)cbuf,0,100);
	strncpy(cbuf,(LPCSTR)strArg,100);
	pc=strstr(cbuf,"=");
	// kommt kein '=' vor ?
	// dann den gesamten String zurckgeben
	if(pc==NULL) return "";
	pcEnd=pc+strlen(pc);
	pc++;
	while(*pc==32) pc++;
	while(*(pcEnd-1)==32 && pcEnd>pc) pcEnd--;
	*pcEnd=0;
	strReturn=pc;
	return strReturn;
}


// eine Zeile in einer Section neu setzen
void CProIniSection::SetString(int inr,CString str)
{
	CString *pstrOld;
	CString *pstrNew;

	// den Fall abfangen, da hinter das Ende der Liste gesetzt wird
	if(inr>m_list.GetCount()) return;

	// alten String holen
	pstrOld=(CString *)m_list.GetAt(m_list.FindIndex(inr));
	// neuen String zuweisen
	pstrNew=new CString;
	*pstrNew=str;
	m_list.SetAt(m_list.FindIndex(inr),pstrNew);
	// alten String lschen
	if(pstrOld!=NULL) delete pstrOld;

}

// den Anteil eines Strings VOR einem '=' zurckgeben
CString CProIniSection::GetBeforeEqual(CString strArg) const
{
	CString strReturn;
	char cbuf[100];
	char* pcBegin;
	char* pc;
	memset((void *)cbuf,0,100);
	strncpy(cbuf,(LPCSTR)strArg,100);
	pc=strstr(cbuf,"=");
	// kommt kein '=' vor ?
	// dann den gesamten String zurckgeben
	if(pc==NULL) return strArg;
	// rechtsseitig fhrende Spaces eliminieren
	while(*(pc-1)==32 && pc>cbuf) pc--;
	*pc=0;
	pcBegin=cbuf;
	// linksseitig fhrende Spaces eliminieren
	while(*pcBegin==32) pcBegin++;
	
	strReturn=pcBegin;
	return strReturn;

}

// alle Zeilen einer Section lschen
void CProIniSection::DeleteAll()
{
	CString* pstr;
	while(!m_list.IsEmpty())
	{
		pstr=(CString *)m_list.GetTail();
		m_list.RemoveTail();
		delete pstr;
	}
}

// aus einem delimtied String einzelne Teile 
// extrahieren; iPos gibt (zero based) die Pos. an
// als Delimiter wird ein Semikolon verwendet
// z.B. GetListEntry("abc;def;ghi",1) == "def"
// wird von InitComboGrid aufgerufen, um einen
// evtl. bergebenen Formatstring zu parsen
CString CProIniSection::GetListEntry(CString strList, int iPos, char cDelimiter) const
{
	CString str;
	int i;
	char c;
	char cbuf[100];
	const char* pc=(LPCTSTR)strList;
	const char* pcEnd;
	// bis zum Wort # iPos vorgehen
	// d.h. den Anfang des Teilstcks suchen
	i=0;
	while((c=*pc++)!=0 && i<iPos)
	{
		if(c==cDelimiter) i++;
	}
	// Stringende erreicht, bevor das gesuchte Wort gefunden wurde ?
	if(c==0) return "";
	memset((void *)cbuf,0,100);
	// das Ende des Teilstcks suchen
	pc--;
	pcEnd=pc;
	while((c=*pcEnd)!=cDelimiter && c!=0) pcEnd++;
	// das Teilstck in den Zeilspeicher kopieren
	size_t size=(size_t)(pcEnd-pc);
	if(size>99) size=99;
	strncpy(cbuf,pc,size);
	str=cbuf;
	return str;
}


